Summary: Unix2Web Tools
Name: u2webtools_maria
Provides: u2webtools
Version: 9.5
Release: 2
distribution: SUSE Linux Enterprise Server 11
License: GPL
Group: Utilities/System
Source: u2webtools_maria-9.5.tgz
BuildRoot: /dev/shm/u2w_my_makerpm
Packager: Henning Sander <sandix@universal-logging-system.org>
Vendor: Universal-Logging-System.org
Conflicts: u2webtools_nomysql u2webtools_mysql

%description
Unix2Web-Http/Https-Server
unix2webd with MariaDB-Extension, httpget, code_http

%prep
echo

%setup
echo

%build
if [[ -d SRC ]]
 then
  if cd SRC
   then
    for i in *
     do
      (cd $i && MYSQL="_maria" make)
    done
  fi
fi

%install
if [[ -n "$RPM_BUILD_ROOT" ]]
 then
  mkdir -p $RPM_BUILD_ROOT
  cp -a `ls| grep -v 'SRC'` $RPM_BUILD_ROOT/
else
  rm -rf /dev/shm/u2w_my_makerpm
  mkdir -p /dev/shm/u2w_my_makerpm
  cp -a `ls| grep -v 'SRC'` /dev/shm/u2w_my_makerpm
fi
if [[ -d SRC ]]
 then
  if cd SRC
   then
    for i in *
     do
      (cd $i && MYSQL="_maria" PREFIX=${RPM_BUILD_ROOT:-/dev/shm/u2w_my_makerpm}/usr make install)
    done
  fi
fi

%files
%defattr(-,root,root) 
%attr(755,root,root) %dir /etc/unix2web
%attr(644,root,root) /usr/share/locale/de/LC_MESSAGES/httpget.mo
%attr(644,root,root) /usr/share/locale/de/LC_MESSAGES/unix2web.mo
%attr(644,root,root) /etc/pam.d/unix2webd
%attr(644,root,root) /etc/unix2web/unix2web.conf.template
%attr(755,root,root) /etc/init.d/unix2web
%attr(755,root,root) /usr/bin/code_http
%attr(755,root,root) /usr/bin/httpget
%attr(755,root,root) /usr/bin/u2w_interpreter
%attr(755,root,root) /usr/bin/u2w_passwd
%attr(755,root,root) /usr/bin/unix2webd

%pre
if [[ "$1" != "1" ]]
 then
  OLDMAJOR=`rpm -qa | grep u2webtools | sort | tail -1 | sed 's/[^-]*-\([0-9]*\)[.].*/\1/'`
  if [[ $OLDMAJOR -lt 9 ]]
   then
    if cd /etc/unix2web
     then
      echo "Converting config-files to new version"
      echo $OLDMAJOR >/tmp/u2webtools_update_old_version
      find . -name '*.conf' -type f | while read f
       do
        echo "Saving $f to $f.v$OLDMAJOR"
        mv $f $f.v$OLDMAJOR
        echo "###############################
#
# converted from $f.v$OLDMAJOR
#
###############################
#" >$f
        awk -F '=' '
BEGIN { n = 1 }
$1 !~ "#" { p[n] = $1
            v[$1] = $2
            z[n++] = $0
          }
END { if( v["U2WPARS"] !~ "-U[^U]" && !v["U2WUSER"] && !v["SWITCHUSER"] )
      { v["U2WUSER"]="nobody"
        uflag = 1
      }
      for( i = 1; i < n; i++ )
      { if( p[i] == "U2WUSER" )
        { if( v["U2WPARS"] ~ "-UU" )
            print "U2WSETUSER=" v["U2WUSER"]
          else
            print "U2WDEFUSER=" v["U2WUSER"]
          uflag = 0
        }
        else if( p[i] == "U2WPARS" )
        { gsub(" -c  *", " ", v["U2WPARS"])
          gsub("\"-c  *", "\"", v["U2WPARS"])
          gsub(" -U[U]?  *", " ", v["U2WPARS"])
          gsub("\"-U[U]?  *", "\"", v["U2WPARS"])
          print "U2WPARS=" v["U2WPARS"]
        }
        else if( p[i] != "WAITCONNECTION" )
          print z[i]
      }
      if( uflag )
        print "U2WDEFUSER=" v["U2WUSER"]
    }' $f.v$OLDMAJOR >>$f
      done
    fi
  else
    rm -f /tmp/u2webtools_update_old_version
  fi
fi

%post
if [[ "$1" = "1" ]]
 then
  if which insserv >/dev/null 2>&1
   then
    insserv unix2web
  elif which chkconfig >/dev/null 2>&1
   then
    chkconfig unix2web on
  else
    echo "you have to enable the service unix2web"
  fi
else
  if [[ -f /tmp/u2webtools_update_old_version ]]
   then
    V=$(</tmp/u2webtools_update_old_version)
    if [[ $V -lt 9 ]]
     then
      if cd /etc/unix2web
       then
        ls *.conf | while read f
         do
          PORT=$(awk -F '=' '$1 == "U2WPORT" {p = $2};END {print p}' $f)
          if [[ -z "$PORT" ]]
           then
            PORT=$(. $f >/dev/null 2>&1; echo $U2WPORT)
          fi
          if [[ -n "$PORT" ]]
           then
            TPID=$(ps -efa | awk '$3 == 1 && $0 ~ "unix2webd.*-p '$PORT' " {print $2}')
            if [[ -n "$TPID" ]]
             then
              echo
              echo "stopping old server"
              kill $TPID
              while [[ -d /proc/$TPID ]]
               do
                usleep 100000
              done
              usleep 500000
              echo "starting new server"
              if /etc/init.d/unix2web start $f
               then
                echo ""
              else
                sleep 1
                /etc/init.d/unix2web start $f
              fi
            fi
          fi
        done
      fi
    fi
  fi
fi

%preun
if [[ "$1" = "0" ]]
 then
  /etc/init.d/unix2web stop
  if which insserv >/dev/null 2>&1
   then
    insserv -r -f unix2web
  elif which chkconfig >/dev/null 2>&1
   then
    chkconfig unix2web off
  else
    echo "unable to disable service unix2web"
  fi
fi

%clean
if [[ -n "$RPM_BUILD_ROOT" ]]
 then
  rm -rf $RPM_BUILD_ROOT
else
  rm -rf /dev/shm/u2w_makerpm
fi

%changelog
* Sat Dec  9 2017 sandix@universal-logging-system.org
- continue reading on buffer overflow
* Thu Sep 21 2017 sandix@universal-logging-system.org
- -Xi <inifile> to define system variables
* Sat Aug 12 2017 sandix@universal-logging-system.org
- detect too large POST data and answer with HTTP-413
* Sun Jun  4 2017 sandix@universal-logging-system.org
- added u2w-file to errorlogging
* Thu May  4 2017 sandix@universal-logging-system.org
- /etc/init.d/unix2web: write to /var/log/unix2web.log
* Sun Mar 19 2017 sandix@universal-logging-system.org
- bugfix: wrong parametercount in %checkid(...)
* Sat Feb 18 2017 sandix@universal-logging-system.org
- bugfix: disabled buggy code for "range" requests
- changed behaviour auf statements in "..." to interprete
-   after %if, %elif and %while
* Tue Feb 14 2017 sandix@universal-logging-system.org
- bugfix: %queryvars and %hidenvars - variables with multiple values
- new switch: -fS <maxfilesize> set maximum size of post files in bytes
* Thu Jul 14 2016 sandix@universal-logging-system.org
- bugfix: Html Pars in %mysqlread
* Tue Mar 29 2016 sandix@universal-logging-system.org
- new functions: %useragent, %uatype
* Sun Mar 13 2016 sandix@universal-logging-system.org
- new function: %queryvars
* Sun Feb  7 2016 sandix@universal-logging-system.org
- new %heads: %head with u2w-scripts
* Sat Oct  3 2015 sandix@universal-logging-system.org
- new option -Q: enable statuspage
* Sat Sep 19 2015 sandix@universal-logging-system.org
- new option -G <numbacklog>, set backlog in listen()
* Mon Sep  7 2015 sandix@universal-logging-system.org
- new option -SF
* Wed Sep  2 2015 sandix@universal-logging-system.org
- enabled non-blocking in SSL-handshake
* Sun Jul  5 2015 sandix@universal-logging-system.org
- enabled title and value for %pbutton
* Mon May  4 2015 sandix@universal-logging-system.org
- new function "checkid"
- bugfix in u2w_menu
* Tue Mar 17 2015 sandix@universal-logging-system.org
- new function "delonexit"
* Fri Feb  6 2015 sandix@universal-logging-system.org
- some fixes in read from browser routines
* Thu Sep 25 2014 sandix@universal-logging-system.org
- fixed bug in read multipart content blocks
* Thu Sep 18 2014 sandix@universal-logging-system.org
- fixed bug in nonblocking ssl reading on timout
* Tue Aug 26 2014 sandix@universal-logging-system.org
- fixed bug in nonblocking ssl reading
- fixed bug in reading partial multipart-content header
* Tue Jun 24 2014 sandix@universal-logging-system.org
- fixed bug in converting conf-files from version 8 to 9
* Fri Apr 25 2014 sandix@universal-logging-system.org
- fixed delete post files after SIGPIPE
* Wed Feb 19 2014 sandix@universal-logging-system.org
- fixed %colspan and %rowspan
* Sun Feb 16 2014 sandix@universal-logging-system.org
- some new css defs
* Tue Sep 10 2013 sandix@universal-logging-system.org
- fixed httpget
* Tue Jul  9 2013 sandix@universal-logging-system.org
- fixed some bugs
* Tue Apr  9 2013 sandix@universal-logging-system.org
- added mysqlconnect with characterset
* Sat Jan  5 2013 sandix@universal-logging-system.org
- first V 9.0.0 release
* Sat Dec 29 2012 sandix@universal-logging-system.org
- added -Dp for Pidfile and moved binaries to /usr/bin
* Wed Feb 8 2012 sandix@universal-logging-system.org
- patches in unix2webd
* Thu Sep 15 2011 sandix@universal-logging-system.org
- patch httpget to V 2.2.3
* Mon Feb 7 2011 sandix@universal-logging-system.org
- upgrade httpget to v 2.2.2
* Tue Feb 1 2011 sandix@universal-logging-system.org
- upgrade httpget to v 2.2.1
* Mon Sep 6 2010 sandix@universal-logging-system.org
- upgrade httpget to v 2.1.4
* Mon May 24 2010 sandix@universal-logging-system.org
- upgrade httpget to v 2.1.3
* Mon Nov 16 2009 sandix@universal-logging-system.org
- u2w with language support
* Thu Feb 14 2008 sandix@universal-logging-system.org
- /etc/init.d/unix2web fixed
* Tue Jan 22 2008 sandix@universal-logging-system.org
- new config-files in /etc/u2webtools/*.conf
* Tue Sep 19 2006 sandix@universal-logging-system.org
- first RPM package
